/* chromInfo.h was originally generated by the autoSql program, which also 
 * generated chromInfo.c and chromInfo.sql.  This header links the database and the RAM 
 * representation of objects. */

#ifndef CHROMINFO_H
#define CHROMINFO_H

struct chromInfo
/* Chromosome names and sizes */
    {
    struct chromInfo *next;  /* Next in singly linked list. */
    char *chrom;	/* Chromosome name */
    unsigned size;	/* Chromosome size */
    char *fileName;	/* Chromosome file (raw one byte per base) */
    };

void chromInfoStaticLoad(char **row, struct chromInfo *ret);
/* Load a row from chromInfo table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct chromInfo *chromInfoLoad(char **row);
/* Load a chromInfo from row fetched with select * from chromInfo
 * from database.  Dispose of this with chromInfoFree(). */

struct chromInfo *chromInfoCommaIn(char **pS, struct chromInfo *ret);
/* Create a chromInfo out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new chromInfo */

void chromInfoFree(struct chromInfo **pEl);
/* Free a single dynamically allocated chromInfo such as created
 * with chromInfoLoad(). */

void chromInfoFreeList(struct chromInfo **pList);
/* Free a list of dynamically allocated chromInfo's */

void chromInfoOutput(struct chromInfo *el, FILE *f, char sep, char lastSep);
/* Print out chromInfo.  Separate fields with sep. Follow last field with lastSep. */

#define chromInfoTabOut(el,f) chromInfoOutput(el,f,'\t','\n');
/* Print out chromInfo as a line in a tab-separated file. */

#define chromInfoCommaOut(el,f) chromInfoOutput(el,f,',',',');
/* Print out chromInfo as a comma separated list including final comma. */

#endif /* CHROMINFO_H */

